///////////////////////////////////////////////////////////////////////////////
//
// Screen.cpp
//
//
//
//
//
///////////////////////////////////////////////////////////////////////////////
#include "Screen.h"
#include <bitdev.h>
#include <w32std.h>


///////////////////////////////////////////////////////////////////////////////
// CScreenBitmap
///////////////////////////////////////////////////////////////////////////////
CScreenBitmap::CScreenBitmap()
	{
	}

///////////////////////////////////////////////////////////////////////////////
void CScreenBitmap::ConstructL(RWsSession& aWs, const TSize& aSize, TDisplayMode aMode)
	{
	iMode = aMode;
	iWs = &aWs;
	ResizeL(aSize);
	}

///////////////////////////////////////////////////////////////////////////////
CScreenBitmap::~CScreenBitmap()
	{
	Reset();
	}

///////////////////////////////////////////////////////////////////////////////
void CScreenBitmap::Reset()
	{
	iDrawer.Reset();

	delete iContext;
	iContext = NULL;

	delete iDevice;
	iDevice = NULL;

	delete iScreenBitmap;
	iScreenBitmap = NULL;
	}

///////////////////////////////////////////////////////////////////////////////
CScreenBitmap::CBitmap* CScreenBitmap::ResetReleaseBitmapLC()
	{
	CBitmap* bitmap = iScreenBitmap;
	iScreenBitmap = NULL;
	Reset();
	CleanupStack::PushL(bitmap);
	return bitmap;
	}

///////////////////////////////////////////////////////////////////////////////
void CScreenBitmap::ResizeL(const TSize& aNewSize)
	{
	if(iScreenBitmap)
		{
		Reset();
		}
	ASSERT(iWs);
	iScreenBitmap = new(ELeave) CBitmap(*iWs);
	User::LeaveIfError( iScreenBitmap->Create(aNewSize, iMode) );
	iDevice = CFbsBitmapDevice::NewL(iScreenBitmap);
	CFbsBitGc* bitGc = NULL;
	User::LeaveIfError( iDevice->CreateContext(bitGc) );
	iContext = bitGc;
	iDrawer.Set(*iScreenBitmap);
	}

///////////////////////////////////////////////////////////////////////////////
void CScreenBitmap::Draw(CBitmapContext& aTargetContext, const TPoint& aPos)
	{
	iDrawer.Draw(aTargetContext, TRect(aPos, Size()));
	}

///////////////////////////////////////////////////////////////////////////////
TSize CScreenBitmap::Size() const
	{
	return (iScreenBitmap) ? (iScreenBitmap->SizeInPixels()) : (TSize(0, 0));
	}

///////////////////////////////////////////////////////////////////////////////
CFbsBitmapDevice* CScreenBitmap::Device()
	{
	return iDevice;
	}

///////////////////////////////////////////////////////////////////////////////
CBitmapContext* CScreenBitmap::Context()
	{
	return iContext;
	}

///////////////////////////////////////////////////////////////////////////////
const CBitmapContext* CScreenBitmap::Context() const
	{
	return iContext;
	}


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
