///////////////////////////////////////////////////////////////////////////////
//
// Screen.h
//
//
//
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef SCREEN_H
#define SCREEN_H

#include <w32std.h>
#include "ScreenUtility.h"
class CFbsBitmapDevice;


///////////////////////////////////////////////////////////////////////////////
// CScreenBitmap
///////////////////////////////////////////////////////////////////////////////
// Off-screen bitmap.
///////////////////////////////////////////////////////////////////////////////
class CScreenBitmap : public CBase
	{
public:
	typedef CWsBitmap CBitmap; // Determines the CFbsBitmap class type used.
public:
	CScreenBitmap();
	void ConstructL(RWsSession&, const TSize& aSize, TDisplayMode aMode=EColor256);
	virtual ~CScreenBitmap();

	void Reset();
	CBitmap* ResetReleaseBitmapLC();
	void ResizeL(const TSize& aNewSize);
	void Draw(CBitmapContext& aTargetContext, const TPoint& aPos);

	TSize Size() const;
	CFbsBitmapDevice* Device();
	CBitmapContext* Context();
	const CBitmapContext* Context() const;

private:
	RWsSession* iWs;
	TDisplayMode iMode;
	TBitmapDrawer iDrawer;
	CBitmap* iScreenBitmap;
	CFbsBitmapDevice* iDevice;
	CBitmapContext* iContext;
	};


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
