///////////////////////////////////////////////////////////////////////////////
//
// GameResourceUtils.h
//
///////////////////////////////////////////////////////////////////////////////
#ifndef _GAMERESOURCEUTILS_H_
#define _GAMERESOURCEUTILS_H_

#include <w32std.h>
#include "Trigonometry.h"

class RResourceFile;
class TResourceReader;

class MGameSpriteObject;
class CGameBitmapSprite;
class CGameSpriteTable;
class MGameObject;
class CGamePlayer;
class CGameModel;

///////////////////////////////////////////////////////////////////////////////
// GameResourceUtils
///////////////////////////////////////////////////////////////////////////////
class GameResourceUtils
	{
public:
	static void OpenResourceLC(RResourceFile& aFile, RFs &aFs, const TDesC& aName, TInt aSignature=0);
	static void ReadResourceLC(const RResourceFile& aFile, TInt aResourceId, TResourceReader& aReader);
public:
	static TPoint ReadTPoint(TResourceReader& aReader);
	static TSize ReadTSize(TResourceReader& aReader);
	static TTrigUnit ReadTTrigUnit(TResourceReader& aReader);
	static TTrigXY ReadTTrigXY(TResourceReader& aReader);
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif