///////////////////////////////////////////////////////////////////////////////
//
// Physics.h
//
//
//
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef PHYSICS_H
#define PHYSICS_H

#include "Trigonometry.h"


///////////////////////////////////////////////////////////////////////////////
// TVector
///////////////////////////////////////////////////////////////////////////////
class TVector : public TTrigXY
	{
public:
	inline TVector();
	inline TVector(const TTrigUnit&, const TTrigUnit&);
	inline TVector(const TTrigXY&);
	inline TVector& operator= (const TVector&);
	inline TVector& operator+=(const TVector&);
	inline TVector& operator-=(const TVector&);
	inline TVector& operator*=(const TVector&);
	inline TVector& operator/=(const TVector&);
	inline TVector& operator%=(const TVector&);
	inline TVector& operator= (const TTrigUnit&);
	inline TVector& operator+=(const TTrigUnit&);
	inline TVector& operator-=(const TTrigUnit&);
	inline TVector& operator*=(const TTrigUnit&);
	inline TVector& operator/=(const TTrigUnit&);
	inline TVector& operator%=(const TTrigUnit&);
	inline TVector operator+(const TVector&) const;
	inline TVector operator-(const TVector&) const;
	inline TVector operator*(const TVector&) const;
	inline TVector operator/(const TVector&) const;
	inline TVector operator%(const TVector&) const;
	inline TVector operator+(const TTrigUnit&) const;
	inline TVector operator-(const TTrigUnit&) const;
	inline TVector operator*(const TTrigUnit&) const;
	inline TVector operator/(const TTrigUnit&) const;
	inline TVector operator%(const TTrigUnit&) const;
public:
	inline void Set(const TTrigUnit&, const TTrigUnit&);
	void SetUnit();
	void Normalize();
	TDirection Direction() const;
	TTrigUnit Magnitude() const;
	TDirection Angle(const TVector&) const;
	TTrigUnit ScalarProduct(const TVector&) const;
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#include "Physics.inl"

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif